// Main.c
#include <REGAN21.H>			/* Register des AN21xx	*/
#include <EZRegsHEAD.H>			/* Externe Register des AN21xx  */


#include "onewireHEAD.h" 
#include "SearchRomHEAD.h" 
#include "essential_ROM_CommandsHEAD.h"	


// Belegung des Speichers
volatile unsigned char LED_BLINK;	// LED blinken lassen
volatile unsigned char LED_COUNT;	// Blinkende LED - Zhler nach Timer


xdata unsigned char tempB1 _at_ 0x0119;
xdata unsigned char tempB2 _at_ 0x011A;
xdata unsigned char var0 _at_ 0x011B;
xdata unsigned char var1 _at_ 0x011C;
xdata unsigned char var2 _at_ 0x011D;
xdata unsigned char var3 _at_ 0x011E;
xdata unsigned char var4 _at_ 0x011F;
xdata unsigned char var5 _at_ 0x0120;
xdata unsigned char var6 _at_ 0x0121;
xdata unsigned char var7 _at_ 0x0122;

// Erluterung der Speicherstruktur: TRM Abschnitt 3-1


/*------------------------------------------------
The main C function.  Program execution starts
here after stack initialization.
------------------------------------------------*/
void main()
{	EA = 0;
	// Ohne die folgenden 5 Zeilen kann das USB-Board sich nicht am USB-Port melden,
	// wenn Sie aus der IIC- Datei ein EEPROM herstellen!!!
	EUSB = 1; // Enable Firmware- USB
	USBCS = 4;
	USBIRQ = 0x1E;
	IBNIRQ = IBNIEN = TOGCTL = 0;
	EPIO[0] = 0x0A; // Enable Firmware- USB Ende


	// fr die verschiedenen Bedeutungen der Krzel siehe Technical Manual Abschnitt C-24
						 
	EA = 1; // Interrupts generell frei geben 
	ET0 = 1; // Interrupt fr Timer 0 enablen
	CT0 = 0; // Quelle fr den Timer: Clck24 (=1 wre Pin T0)
	T0M = 0; // Frequenz des Timers: Clock/12 (=1 wre Clck24/4 -> schneller)
	TL0 = 0;
	TH0 = 0; 
	TR0=1; // TimerRun (Timer aktivieren)

	LED_BLINK = 1; // Blinken in der Software aktivieren
	LED_COUNT = 1;

	PORTACFG = 0; // PortA  auf IO-konfigurieren
	PORTCCFG = 0;
	OEA = 0xFF;
	OEC = 0xFF;
						

var0=0;
var1=0;
var2=0;
var3=0;
var4=0;
var5=0;
var6=0;


	while(1)
	{
		var3++; 
		OUTC=0xAA;
		var0 = OWFindFamily(0x22);	  			 
		var1 = Dev[0].romcode[0];
		var2 = Dev[0].romcode[1];
		var4 = Dev[1].romcode[0];	
		var5 = Dev[1].romcode[1];
		 
		var6 = Dev[2].romcode[1];

	}
		

}


//
// Timer fr ms- Zhler	(bringt die LED A4 blinken)

void T0_isr (void) interrupt 1 // fr genauere Erklrung siehe hier: http://www.keil.com/support/man/docs/c51/c51_le_interruptfuncs.htm
{
	if (LED_BLINK)
	{
		if (LED_COUNT-- == 0)	// Zhler zurcksetzen
		{	LED_COUNT = 50;		// Schleifenzhler neu setzen
			OUTA ^= 0x10;		// LED umschalten
		}
	}
}