// essential_ROM_Commands.c
#include "essential_ROM_CommandsHEAD.h"		
#include "onewireHEAD.h"	 		
#include "searchRomHEAD.h"	 


xdata DEVICE Dev[MAX_NUM_OF_DEVICES]; // MAX_NUM_OF_DEVICES und DEVICE wurde in "essential_ROM_CommandsHEAD.h" festgelegt
unsigned char numDev = 0;	// Number of devices



unsigned char OWFindAll()
{
	unsigned char temp_numDev, i, j, rslt;

	// reset search-state (no found roms)
	for (i = 0; i < MAX_NUM_OF_DEVICES; i++)
	{
		for (j = 0; j < 8; j++) Dev[i].romcode[j] = 0;
	}
	temp_numDev=0;

	// begin search
	rslt = OWFirst();
	if (rslt) rslt = OWVerify(); // Verify presence of device ROM_NO
	while (rslt && (temp_numDev < MAX_NUM_OF_DEVICES))
	{
		for (i = 0; i<8; i++)
		{	// Store found ROM-number of ROM_NO-buffer in FoundROM
				Dev[temp_numDev].romcode[i] = ROM_NO[i];
		}
		temp_numDev++;
		rslt = OWNext(); // search for other devices
		if (rslt) rslt = OWVerify();
	}
	numDev = temp_numDev;

	return numDev;
}	  



// finds all devices of one family, clears the memory "Dev[]" and stores the found devices of the family in it
unsigned char OWFindFamily(unsigned char family_code)
{													
	unsigned char temp_numDev, i, j, rslt;

	// reset search-state (no found roms)
	for (i = 0; i < MAX_NUM_OF_DEVICES; i++)
	{
		for (j = 0; j < 8; j++) Dev[i].romcode[j] = 0;
	}
	temp_numDev = 0;																									  

	// begin search
	OWTargetSetup(family_code);
	rslt = OWNext();
	if (rslt) rslt = OWVerify(); // Verify presence of device ROM_NO
	while (rslt && (temp_numDev < MAX_NUM_OF_DEVICES) && (ROM_NO[0] == family_code))
	{
		for (i = 0; i<8; i++)
		{	// Store found ROM-number of ROM_NO-buffer in FoundROM
				 Dev[temp_numDev].romcode[i] = ROM_NO[i];
		}
		temp_numDev++;
		rslt = OWNext(); // search for other devices
		if (rslt) rslt = OWVerify();
	}
	numDev = temp_numDev;

	return numDev;
}


void OWMatchRom(unsigned char* romcode)
{
	unsigned char i;

	OWReset();
	for (i=0; i<8; i++)
		OWWriteByte(romcode[i]);
}
























/*
	unsigned char temp_numDev, i, j, rslt, firstapp, lastapp;

	// records the position of the first and the last stored data of found devices of family "family_code" in Dev[]-memory
	firstapp = 255;
	for (i = 0; i < MAX_NUM_OF_DEVICES; i++)
	{ 
		if (Dev[i].romcode[0] == family_code)
		{
			if (i < firstapp) firstapp = i;
			lastapp = i;
		}
	}

	// move all data, which originally followed the last stored device  
	if (firstapp != 255)
	{
		for (i = 0; lastapp + 1 + i < MAX_NUM_OF_DEVICES; i++)
		{
			for (j = 0; j < 8; j++)
				Dev[firstapp + i].romcode[j] = Dev[lastapp + 1 + i].romcode[j];
		}
	}




*/